/*
 ⨬   ਭ

     optimal.txt
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <values.h>
#include <dos.h>   /*쪮  ⫠ - . delay()*/

#define ROWS 50 /* ᨬ쭮 ᫮ ப */
#define COLS 50 /* ᨬ쭮 ᫮ ⮫殢 */
#define WAY 1000 /*  ᨬ쭮   ਭ */
char Lab[ROWS][COLS];

////////////   ࢨ 㭪権  ࠡ  ࠭
void TextColor (int Col, int Bk) { textcolor (Col); textbackground (Bk); }

void Logo (void) { //⨯ ணࠬ
 clrscr();
 gotoxy (1,25);
 TextColor (BLACK,LIGHTGRAY);
 cprintf ("%79s\r","Optimal labyrinth way. "
	  "Needs DOS mode "
	  "for normal working");
 window (1,1,80,24);
 window (3,3,78,23); TextColor (YELLOW,BLUE); clrscr();
}

void Error (int Code) { //饭  訡  襭 ࠡ
 char *Msg[]={
  "",
  "Optimal labyrinth way. Give me file name as parameter",
  "File open error",
  "Read data error",
  "Invalid labyrinth dimension",
  "Can't read matrix from '*' and ' ' symbols from this file",
  "Overflow - the way is too long. Increase the value WAY in program"
 };
 fcloseall();
 cprintf ("\r\n Errorcode=%d:\r\n %s!\r\n Press ENTER...",Code,Msg[Code]);
 fflush (stdin); getch();
 window (1,1,80,25); TextColor (LIGHTGRAY,BLACK); clrscr();
 exit (Code);
}
////////////    ࢨ 㭪権  ࠡ  ࠭

////////////   㭪権 ࠡ  䠩
FILE *Open(char *Name, char *Mode) { //⨥ 䠩
 FILE *f;
 f=fopen (Name,Mode);
 if (f==NULL) Error (2);
 return f;
}
////////////    㭪権 ࠡ  䠩

 //     :
 int Rows,Cols; //᫮ ப  ⮫殢 ਭ
 char Way[WAY][3], OptWay[WAY][3], //騩  ⨬ 
  // ⮫ ᨢ Way:
  //                 ⪠ 砫 ⢨  ⮩
  // ப        ⮫     窥 ਭ (0  1)
      In[2][2], //ப  ⮫ 室  室 ਭ
      CRow,CCol, //騥 ப  ⮫
      Dir=0;     //饥 ࠢ
#define MAX_LEN (ROWS-1)*(COLS-1)
 /* 讥 ᫮  祭  ⥩ -
     ⮩ 稭    ⥩  ਭ */
 int MinLen=MAXINT,Len; /* 쭠  ⥪   */
     //쭠  樠஢ 訬 楫 ᫮

void WriteLab (char CRow, char CCol, char Dir) {
 //⫠筠  ਭ
 int i,j; char p;
 static char First; static int OldRow,OldCol;
 if (!First) { //⠥  ࠧ  ਭ  塞
	       //  㣨 梥⮬
  for (i=0; i<Rows; i++) {
   cprintf ("\r\n");
   for (j=0; j<Cols; j++) {
    p=Lab[i][j];
    switch (p) {
     case '*': TextColor (YELLOW,BLUE); break;
     case ' ': TextColor (GREEN,BLUE);  p=0xfe; break;
    }
    cprintf ("%c",p);
   }
  }
  First=0x01;
 }
 else { // 筮  ஡ , 
	//뫨  ⮣   ,  室 ᥩ
  gotoxy (OldCol+1,OldRow+2);
  TextColor (GREEN,BLUE);
  cprintf (" ");
  gotoxy (CCol+1,CRow+2);
  switch (Dir) { //⠥  ᨬ  ᨬ  ࠢ
   case 0: p='^'; break; //
   case 1: p='>'; break;
   case 2: p='|'; break;
   case 3: p='<'; break;
  }
  cprintf ("%c",p);
 }
 OldRow=CRow; OldCol=CCol;
}

void PrintLab (FILE *w) {
 // ਭ  䠩
 int i,j;
 for (i=0; i<Rows; i++) {
  fprintf (w,"\n");
  for (j=0; j<Cols; j++) fprintf (w,"%c",Lab[i][j]);
 }
 fclose (w);
}

void OptLab (char CRow, char CCol, char Dir) { // 㭪
 char Ways,Dirs[4]={'\x0','\x0','\x0','\x0'},j;
 int i;

 do {
  WriteLab (CRow,CCol,Dir);  // 
  delay (10);   	     //  !

  // :
  //᫨  窠 㦥 砫  ⮬  (⨬  
  // ᮤঠ ᠬ祭)  ⥪  
  // ࠭  - 
  for (i=0,j=0; i<Len; i++) if ((Way[i][0]==CRow) && (Way[i][1]==CCol)) {
   j=1; break;
  }
  if ((j) || (Len>MinLen)) return;

  if ( (CRow==In[1][0]) && (CCol==In[1][1]) ) { //  !
   if (Len<MinLen) { //諨 祭    MinLen -
    MinLen=Len+1;    // 
    for (i=0; i<MinLen; i++) for (j=0; j<3; j++) OptWay[i][j]=Way[i][j];
   }
   return;
  }
  //業 ⢮ ⥩  ⥪饣 㭪 (  㭪,
  //㤠 諨,  ⠥, ..   室  ⨬ )
  Ways=0;
  if ( (CRow>0) && (Lab[CRow-1][CCol]==' ') && (Dir!=2) ) {
   Ways++; Dirs[0]=1; } //   ?
  if ( (CCol<Cols-1) && (Lab[CRow][CCol+1]==' ') && (Dir!=3)) {
   Ways++; Dirs[1]=1; } //   ࠢ?
  if ( (CRow<Rows-1) && (Lab[CRow+1][CCol]==' ') && (Dir!=0)) {
   Ways++; Dirs[2]=1; } //   ?
  if ( (CCol>0) && (Lab[CRow][CCol-1]==' ') && (Dir!=1)) {
   Ways++;  Dirs[3]=1; } //   ?
  //쪮  ⥩?
  switch (Ways) {
   case 0: // ⮫쪮   -    
	   //  ᫥ ⢫
   return;
   case 1: // த ,  ᮧ  ⢥ 
    i=0; while (!Dirs[i]) i++; // ࠢ ᢮?
    Dir=i;                     //  ⮬ ⠫  Dirs
    switch (Dir) {
     case 0:  CRow--; break;
     case 2:  CRow++; break;
     case 1:  CCol++; break;
     case 3:  CCol--; break;
    }
    Dirs[Dir]=0; Len++; //ᨫ ᨢ Dirs 
			// 㢥稫  ⥪饣 
    Way[Len][0]=CRow; Way[Len][1]=CCol; Way[Len][2]=0;
     //ᠫ   ᤥ 蠣
   continue; // த  砫 横 do
   default: //  1    㧫
    for (i=0; i<4; i++) if (Dirs[i]) { //ॡࠥ  
     Way[Len][2]=1; //砥  ⢫,
     Len++;         //㢥稢   ⥪饣 
     switch (i) {   // 蠣  । ࠢ
      case 0:  CRow--; break;
      case 2:  CRow++; break;
      case 1:  CCol++; break;
      case 3:  CCol--; break;
     }
     Way[Len][0]=CRow; Way[Len][1]=CCol;  //뢠 । न
     Dirs[i]=0; //뢠  ࠢ   横
		//᫥   ४ᨨ
     OptLab (CRow,CCol,i); //뢠 㭪 ४ᨢ   㧫
     //  㫨  OptLab - , ࠡ⠫ ࠭祭
     for (Len--; Len>0; Len--) if (Way[Len][2]) break;
      //   न⠬,   諨   ⢫
     CRow=Way[Len][0]; CCol=Way[Len][1]; //頥  ।饬 㧫
     continue; //த 横  ᫥饣 ࠢ
    }
    Way[Len][2]=0;  //ॡࠫ   -    窠 ⢫!
   return; // ࠢ   㧫 ௠ -
	   //  ।騩 㧥   ࠡ
  }
 } while (1);
}

void CheckLab (void) {
 //஢ઠ ਭ  ࠢ쭮
 // 맮 㭪樨 ᪠  ਭ
 FILE *w; //  뢮
 int i,j; char Yes=0,Dir;

 w=Open("optimal.txt","wt");
 for (i=0; i<Rows; i++) { //饬 室  室:
  if ((i==0) || (i==Rows-1)) {
   for (j=1; j<Cols-1; j++) {
    if (Lab[i][j]==' ') { In[Yes][0]=i; In[Yes++][1]=j; }
    else if (Lab[i][j]!='*') Error (5);
   }
   if ( (Lab[i][0]!='*') || (Lab[i][Cols-1]!='*') )
    Error (5); //  "㣫" ਭ!
  }
  else {
   if (Lab[i][0]==' ') { In[Yes][0]=i; In[Yes++][1]=0; }
   else if (Lab[i][0]!='*') Error (5);
   if (Lab[i][Cols-1]==' ') { In[Yes][0]=i; In[Yes++][1]=Cols-1; }
   else if (Lab[i][Cols-1]!='*') Error (5);
  }
  if (Yes>2) Error (5); //  1 室  1 室, 騥   㣫
 }
 CRow=In[0][0]; CCol=In[0][1]; //騥 न 
 if (In[0][0]==0) Dir=2;             //
 else if (In[0][0]==Cols-1) Dir=0;   //
 else if (In[0][1]==0) Dir=1;        //ࠢ
 else Dir=3;                      //
 Len=0;
 Way[Len][0]=CRow; Way[Len][1]=CCol; Way[Len][2]=0; //⮢  1- 蠣

 OptLab (CRow,CCol,Dir);

 if (MinLen<MAXINT) { //᫨ MinLen 﫠 -  訫 
  fprintf (w, "\n 襭 祭!");
  for (i=0; i<MinLen; i++) Lab[OptWay[i][0]][OptWay[i][1]]='o';
 }
 else fprintf (w, "襭 !");
 PrintLab (w);
}


int main (int argc, char *argv[]) {
 FILE *f;
 int i,j;

 Logo();
 if (argc>1) {
  if ((argv[1][0]=='/') || (argv[1][0]=='?')) Error (1);
  else f=Open(argv[1],"rt");
 }
 else Error (1);

 fscanf (f,"%d",&Rows);
 fscanf (f,"%d",&Cols);
 if ( (Rows<1) || (Rows>50) || (Cols<1) || (Cols>50)) Error (4);
 for (i=0; i<Rows; i++) {
  fscanf (f,"\n");
  for (j=0; j<Cols; j++) fscanf (f,"%c",&Lab[i][j]);
 }
 fclose (f);

 CheckLab ();

 cprintf ("\r\n See the file optimal.txt!");
 fflush (stdin); getch();
 Error (0);
 return 0;
}
